/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.atl.afaultdetection.utils;

import com.atl.mcod.utils.Constants;
import java.time.Instant;
import java.util.Iterator;
import java.util.Map;

/**
 *
 * @author thanasis
 */
public class Utils {
    public static double normalize(double value, double minValue, double maxValue){
        return (value - minValue) / (maxValue - minValue);
    }

    public static boolean allIteratorsHaveNext(Map<String,Iterator<Map.Entry<Instant,Double>>> slideDataIteratorsMap) {
        for(Map.Entry<String, Iterator<Map.Entry<Instant,Double>>> entry : slideDataIteratorsMap.entrySet()){
            if(!entry.getValue().hasNext()){
                return false;
            }
        }
        return true;
    }
    
    public static String checkRuleBasedParameters(Map<String, Measurement> measMap) {
        String ruleMeas = "";
        if (Constants.algorithms.contains("mcod") && Constants.maxRule == null && Constants.minRule == null) {
            System.err.println("No rule set for the rule based");
            System.exit(5);
        }
        if (Constants.algorithms.contains("mcodKnowledge") && Constants.maxRule_k == null && Constants.minRule_k == null) {
            System.err.println("No rule set for the rule based knowledge");
            System.exit(5);
        }
        if (Constants.maxRule != null) {
            String ruleQuickMeas = Constants.maxRule.split("-")[0];
            if (!measMap.containsKey(Constants.measShortNameMap.get(ruleQuickMeas))) {
                System.err.println("The measurement of the max rule should be passed using the --meas flag");
                System.exit(6);
            }
            ruleMeas = Constants.measShortNameMap.get(ruleQuickMeas);
        }
        if (Constants.minRule != null) {
            String ruleQuickMeas = Constants.minRule.split("-")[0];
            if (!measMap.containsKey(Constants.measShortNameMap.get(ruleQuickMeas))) {
                System.err.println("The measurement of the min rule should be passed using the --meas flag");
                System.exit(7);
            }
            ruleMeas = Constants.measShortNameMap.get(ruleQuickMeas);
        }
        if (Constants.maxRule_k != null) {
            String ruleQuickMeas = Constants.maxRule_k.split("-")[0];
            if (!measMap.containsKey(Constants.measShortNameMap.get(ruleQuickMeas))) {
                System.err.println("The measurement of the max rule should be passed using the --meas flag");
                System.exit(6);
            }
            ruleMeas = Constants.measShortNameMap.get(ruleQuickMeas);
        }
        if (Constants.minRule_k != null) {
            String ruleQuickMeas = Constants.minRule_k.split("-")[0];
            if (!measMap.containsKey(Constants.measShortNameMap.get(ruleQuickMeas))) {
                System.err.println("The measurement of the min rule should be passed using the --meas flag");
                System.exit(7);
            }
            ruleMeas = Constants.measShortNameMap.get(ruleQuickMeas);
        }
        return ruleMeas;
    }

    public static boolean checkRule(String ruleType, String key, double value, String ruleMeas) {
        if (key.equals(ruleMeas)) {
            if(ruleType.equals("ruleBased")){
                if (Constants.maxRule != null) {
                    if (value > Double.valueOf(Constants.maxRule.split("-")[1])) {
                        return true;
                    }
                }
                if (Constants.minRule != null) {
                    if (value < Double.valueOf(Constants.minRule.split("-")[1])) {
                        return true;
                    }
                }
            } else {
                if (Constants.maxRule_k != null) {
                    if (value > Double.valueOf(Constants.maxRule_k.split("-")[1])) {
                        return true;
                    }
                }
                if (Constants.minRule_k != null) {
                    if (value < Double.valueOf(Constants.minRule_k.split("-")[1])) {
                        return true;
                    }
                }
            }

        }
        return false;
    }
}
