/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.atl.mcod;

import java.util.Set;
import com.atl.mcod.ComposedSplitFunction;
import com.atl.mcod.DistanceFunction;
import com.atl.mcod.DistanceFunctions;
import com.atl.mcod.MTree;
import com.atl.mcod.PartitionFunctions;
import com.atl.mcod.PromotionFunction;
import com.atl.mcod.utils.Data;
import com.atl.mcod.utils.Pair;
import com.atl.mcod.utils.Utils;

/**
 *
 * @author thanasis
 */
class MTreeClass extends MTree<Data> {

    private static final PromotionFunction<Data> nonRandomPromotion = new PromotionFunction<Data>() {
        @Override
        public Pair<Data> process(Set<Data> dataSet, DistanceFunction<? super Data> distanceFunction) {
            return Utils.minMax(dataSet);
        }
    };

    MTreeClass() {
        super(25, DistanceFunctions.EUCLIDEAN, new ComposedSplitFunction<Data>(nonRandomPromotion,
                new PartitionFunctions.BalancedPartition<Data>()));
    }

    public void add(Data data) {
        super.add(data);
        _check();
    }

    public boolean remove(Data data) {
        boolean result = super.remove(data);
        _check();
        return result;
    }

    DistanceFunction<? super Data> getDistanceFunction() {
        return distanceFunction;
    }
};