package com.atl.mcod.utils;

import com.atl.afaultdetection.utils.Measurement;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class Constants {
    
    public static boolean debug = false;
            
    public static double stamperLockedPosition = 2198;
    public static int stabilizationPeriod = 10;
    public static String resutlsDB = "BoostAnmlyDtctn";
    public static String resutlsDBTable = "anomalies2";
    
    public static String maxRule;
    public static String minRule;    
    public static String maxRule_k;
    public static String minRule_k;
    public static Set<String> algorithms;
    
    public static double R = 0.05;
    public static int k = 50;
    public static int W = 3600;
    public static int slide = 360;
    public static double outlierLife = 0.1; //the life of the outlier expressed in percentage of total slides per window (i.e. how many slides should the outlier be active to be reported)
    
    public static double R_k = 0.05;
    public static int k_k = 720;
    public static double outlierLife_k = 0.1;
    
    public static boolean ssl = false;
    public static boolean verbose = false;

//    public static double R = 0.15;
//    public static int k = 400;
//    public static int W = 3600;
//    public static int slide = 360;
//    public static double outlierLife = 0.7; //the life of the outlier expressed in percentage of total slides per window (i.e. how many slides should the outlier be active to be reported)
//    
//    public static double R_k = 0.08;
//    public static int k_k = 720;
//    public static double outlierLife_k = 0.1; //the life of the outlier expressed in percentage of total slides per window (i.e. how many slides should the outlier be active to be reported)
    
    public static String host;
    public static String port;
    public static String username;
    public static String password;
    public static String database;
    
    public static String sensors = "";
    
        
    public static Map<String,Measurement> measMap = new HashMap<>();
    public static Map<String,String> measShortNameMap = new HashMap<>();
    static{
        measShortNameMap.put("oilLevel","A-ERWAERM1-PRESSE/BL:XXXX:OIL:G01O91M0A011:Oelstand Hintenoil level rear");
        measShortNameMap.put("stamperPosition","A-ERWAERM1-PRESSE/BG:MM:LENGTH:Positionmittel:Stoesselposition gemittelt mm");
        measShortNameMap.put("pressForce","A-ERWAERM1-PRESSE/CF:XXXX:XXXX:IF_CtrlToPlc_TCPIP_Slide_ActVal_TotalForce_F:Stoeselkraft ges amt  total slide force kN");
        measShortNameMap.put("lowPressurePumps","A-ERWAERM1-PRESSE/BP:BAR:OIL:G01O91M0B02:Niederdruck Druckueberwachunglow pressur");
        measShortNameMap.put("highPressurePumps","A-ERWAERM1-PRESSE/BP:BAR:OIL:G01O91M0B01:Hochdruck Druckueberwachunghigh pressure");
        measShortNameMap.put("oilTemperature","A-ERWAERM1-PRESSE/BT:CELSIUS:OIL:G01O91M0A012:Oeltemperatur Hintenoil temperatur rear");
        measShortNameMap.put("productNumber","A-ERWAERM1-PRESSE/CF:XXXX:OTHER:PRODNR:Produktnummer");
        measShortNameMap.put("cylinderPressure1","A-ERWAERM1-PRESSE/BP:BAR:OIL:G09O91M0B111:Zylinder 1 Druck Acylinder 1 pressure A");
        measShortNameMap.put("cylinderPressure2","A-ERWAERM1-PRESSE/BP:BAR:OIL:G09O91M0B111:Zylinder 2 Druck Acylinder 2 pressure A");
        measShortNameMap.put("cylinderPressure3","A-ERWAERM1-PRESSE/BP:BAR:OIL:G09O91M0B111:Zylinder 3 Druck Acylinder 3 pressure A");
        measShortNameMap.put("cylinderPressure4","A-ERWAERM1-PRESSE/BP:BAR:OIL:G09O91M0B111:Zylinder 4 Druck Acylinder 4 pressure A");
        measShortNameMap.put("1_mo","Channel_1_MO");
        measShortNameMap.put("2_mo","Channel_2_MO");
        measShortNameMap.put("3_mo","Channel_3_MO");
        measShortNameMap.put("4_mo","Channel_4_MO");
        measShortNameMap.put("5_mo","Channel_5_MO");
        measShortNameMap.put("6_mo","Channel_6_MO");
        measShortNameMap.put("1_max","Channel_1_MAX");
        measShortNameMap.put("2_max","Channel_2_MAX");
        measShortNameMap.put("3_max","Channel_3_MAX");
        measShortNameMap.put("4_max","Channel_4_MAX");
        measShortNameMap.put("5_max","Channel_5_MAX");
        measShortNameMap.put("6_max","Channel_6_MAX");
        measShortNameMap.put("thick","Thickness");
        measShortNameMap.put("in_tmp","Temperature_in_casing");
        measShortNameMap.put("out_tmp","Temperature_out_casing");
    }
    
    public static void formSensors(){
        if(measMap.isEmpty()){
            System.err.println("No measurements provided!");
            System.exit(9);
        }
        for(String meas : measMap.keySet()){
            sensors += "," + meas;
        }
        //trim the first ','
        sensors = sensors.substring(1);
    }

}
